#---------------------------------------------------------
# This Datapack was made by CommandGeek
# Please do not copy or credit this as your own work!
# Youtube: www.youtube.com/CommandGeek
#---------------------------------------------------------

# Equip
execute as @a[scores={WearToolSneak=1..},tag=!wear_tool_sneak] at @s if entity @e[type=item,distance=..1,tag=wear_tool] run function wear_tool:equip
tag @a[scores={WearToolSneak=1..}] add wear_tool_sneak
tag @a[scores={WearToolSneak=0}] remove wear_tool_sneak
scoreboard players set @a[scores={WearToolSneak=1..}] WearToolSneak 0

# Rotation
execute as @a store result score @s WearToolRot run data get entity @s Rotation[1]

# Mine
execute as @a[scores={WearToolRot=80..},tag=!use_wear_tool,nbt={Inventory:[{Slot:103b,tag:{WearTool:"mine"}}]}] at @s rotated ~ 0 positioned ^ ^ ^1 run function wear_tool:mine
execute as @a[scores={WearToolRot=80..},tag=!use_wear_tool,nbt={Inventory:[{Slot:103b,tag:{WearTool:"mine"}}]}] at @s rotated ~ 0 positioned ^ ^1 ^1 run function wear_tool:mine

# Punch
execute as @a[scores={WearToolRot=80..},tag=!use_wear_tool,nbt={Inventory:[{Slot:103b,tag:{WearTool:"punch"}}]}] at @s rotated ~ 0 positioned ^ ^ ^1.5 run function wear_tool:punch

# Hoe
execute as @a[scores={WearToolRot=80..},tag=!use_wear_tool,nbt={Inventory:[{Slot:103b,tag:{WearTool:"hoe"}}]}] at @s rotated ~ 0 positioned ^ ^ ^1 run function wear_tool:hoe
execute as @a[scores={WearToolRot=80..},tag=!use_wear_tool,nbt={Inventory:[{Slot:103b,tag:{WearTool:"hoe"}}]}] at @s rotated ~ 0 positioned ^ ^1 ^1 run function wear_tool:hoe

# Bow / Crossbow / Trident
execute as @a[scores={WearToolRot=80..},tag=!use_wear_tool,nbt={Inventory:[{Slot:103b,tag:{WearTool:"bow"}}]}] at @s rotated ~ 0 run function wear_tool:bow
execute as @a[scores={WearToolRot=80..},tag=!use_wear_tool,nbt={Inventory:[{Slot:103b,tag:{WearTool:"crossbow"}}]}] at @s rotated ~ 0 run function wear_tool:crossbow

execute as @a[scores={WearToolRot=80..},tag=!use_wear_tool] if data entity @s Inventory[{Slot:103b}].tag.WearTool at @s run function wear_tool:damage
    
tag @a[scores={WearToolRot=80..},tag=!use_wear_tool] add use_wear_tool
tag @a[scores={WearToolRot=..40},tag=use_wear_tool] remove use_wear_tool

kill @e[tag=wear_tool_kill_on_ground,nbt={life:100s}]

# ======================================= Tags =======================================

# Sword
execute as @e[type=item,nbt={Item:{id:"minecraft:wooden_sword"}},nbt=!{Item:{tag:{WearTool:"punch"}}}] run data modify entity @s Item.tag.WearTool set value "punch"
execute as @e[type=item,nbt={Item:{id:"minecraft:stone_sword"}},nbt=!{Item:{tag:{WearTool:"punch"}}}] run data modify entity @s Item.tag.WearTool set value "punch"
execute as @e[type=item,nbt={Item:{id:"minecraft:iron_sword"}},nbt=!{Item:{tag:{WearTool:"punch"}}}] run data modify entity @s Item.tag.WearTool set value "punch"
execute as @e[type=item,nbt={Item:{id:"minecraft:golden_sword"}},nbt=!{Item:{tag:{WearTool:"punch"}}}] run data modify entity @s Item.tag.WearTool set value "punch"
execute as @e[type=item,nbt={Item:{id:"minecraft:doa,pmd_sword"}},nbt=!{Item:{tag:{WearTool:"punch"}}}] run data modify entity @s Item.tag.WearTool set value "punch"
execute as @e[type=item,nbt={Item:{id:"minecraft:netherite_sword"}},nbt=!{Item:{tag:{WearTool:"punch"}}}] run data modify entity @s Item.tag.WearTool set value "punch"

# Shovel
execute as @e[type=item,nbt={Item:{id:"minecraft:wooden_shovel"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:stone_shovel"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:iron_shovel"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:golden_shovel"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:diamond_shovel"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:netherite_shovel"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"

# Pickaxe
execute as @e[type=item,nbt={Item:{id:"minecraft:wooden_pickaxe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:stone_pickaxe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:iron_pickaxe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:golden_pickaxe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:diamond_pickaxe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:netherite_pickaxe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"

# Axe
execute as @e[type=item,nbt={Item:{id:"minecraft:wooden_axe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:stone_axe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:iron_axe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:golden_axe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:diamond_axe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"
execute as @e[type=item,nbt={Item:{id:"minecraft:netherite_axe"}},nbt=!{Item:{tag:{WearTool:"mine"}}}] run data modify entity @s Item.tag.WearTool set value "mine"

# Hoe
execute as @e[type=item,nbt={Item:{id:"minecraft:wooden_hoe"}},nbt=!{Item:{tag:{WearTool:"hoe"}}}] run data modify entity @s Item.tag.WearTool set value "hoe"
execute as @e[type=item,nbt={Item:{id:"minecraft:stone_hoe"}},nbt=!{Item:{tag:{WearTool:"hoe"}}}] run data modify entity @s Item.tag.WearTool set value "hoe"
execute as @e[type=item,nbt={Item:{id:"minecraft:iron_hoe"}},nbt=!{Item:{tag:{WearTool:"hoe"}}}] run data modify entity @s Item.tag.WearTool set value "hoe"
execute as @e[type=item,nbt={Item:{id:"minecraft:golden_hoe"}},nbt=!{Item:{tag:{WearTool:"hoe"}}}] run data modify entity @s Item.tag.WearTool set value "hoe"
execute as @e[type=item,nbt={Item:{id:"minecraft:diamond_hoe"}},nbt=!{Item:{tag:{WearTool:"hoe"}}}] run data modify entity @s Item.tag.WearTool set value "hoe"
execute as @e[type=item,nbt={Item:{id:"minecraft:netherite_hoe"}},nbt=!{Item:{tag:{WearTool:"hoe"}}}] run data modify entity @s Item.tag.WearTool set value "hoe"

# Bow / Crossbow / Trident
execute as @e[type=item,nbt={Item:{id:"minecraft:bow"}},nbt=!{Item:{tag:{WearTool:"bow"}}}] run data modify entity @s Item.tag.WearTool set value "bow"
execute as @e[type=item,nbt={Item:{id:"minecraft:crossbow"}},nbt=!{Item:{tag:{WearTool:"crossbow"}}}] run data modify entity @s Item.tag.WearTool set value "crossbow"

# Wear Tool Tag
execute as @e[type=item,tag=!wear_tool] if data entity @s Item.tag.WearTool run tag @s add wear_tool